@use '../../../global/styles/border';
@use '../../../global/styles/link';
@use '../../../global/styles/breakpoint';

// TODO: Untangle this mess and make it more modular

:host {
	background: var(--digi--color--background--primary);

	@include breakpoint.below-large {
		border-block-start: border.$list;
	}

	@include breakpoint.large {
		background: linear-gradient(90deg, var(--digi--color--background--secondary) 0%, var(--digi--color--background--secondary) 50%, var(--digi--color--background--primary) 50%, var(--digi--color--background--primary) 100%);
		border-block-end: border.$box;
	}

	digi-layout-container {
		display: block;
	}
}

.digi-navigation-main-menu-panel {
	position: relative;
	padding: var(--digi--responsive-grid-gutter) 0;
	display: grid;
	grid-template-columns: 1fr;
	grid-template-areas:
		'close-button'
		'main-link'
		'sub-nav';

	@include breakpoint.below-large {
		width: 100%;
		// margin-inline-start: calc(-1 * var(--digi--responsive-grid-gutter--outer));
		padding-block: 0;
	}

	@include breakpoint.large {
		grid-template-columns: 2fr 1fr;
		grid-template-rows: auto 1fr;
		grid-template-areas:
			'main-link close-button'
			'sub-nav close-button';

		height: calc(var(--panel-overflow-height) + var(--digi--responsive-grid-gutter) * 2);

		&::before {
			content: '';
			background: var(--digi--color--background--primary);
			position: absolute;
			left: calc(100% / 3);
			top: 0;
			bottom: 0;
			right: 0;
		}
	}
}

.digi-navigation-main-menu-panel__main-link {
	grid-area: main-link;
	padding: 0 var(--digi--padding--largest);
	position: relative;

	@include breakpoint.large {
		padding: 0 var(--digi--padding--largest);
		margin-block-end: var(--digi--padding--medium);
	}
}

:host {
	::slotted([slot^='main-link']) {
		@include link.list;

		padding: 0;

		&:focus-visible {
			position: relative;
			z-index: 1;
		}

		@include breakpoint.below-large {
			display: flex;
			align-items: center;
			min-height: var(--digi--global--spacing--largest-6);

			&::after {
				min-height: var(--digi--global--spacing--largest-6);
			}
		}

		@include breakpoint.large {
			font-size: var(--digi--global--typography--font-size--largest);
		}
	}
}

.digi-navigation-main-menu-panel__sub-nav {
	display: block;
	grid-area: sub-nav;
}

.digi-navigation-main-menu-panel__close-button-wrapper {
	display: block;
	grid-area: close-button;
	position: relative;

	@include breakpoint.below-large {
		min-height: var(--digi--global--spacing--largest-6);
		display: flex;
		align-items: center;
		border-block-end: border.$list;

		[data-viewport='large'] {
			display: none;
		}
	}

	@include breakpoint.large {
		justify-self: end;

		[data-viewport='small'] {
			display: none;
		}
	}
}

.digi-navigation-main-menu-panel__close-button {
	--digi--button--color--text--function--default: var(--digi--color--text--secondary);
	--digi--button--color--text--function--hover: var(--digi--color--text--secondary);
	--digi--button--color--text--function--focus: var(--digi--color--text--secondary);
	--digi--button--color--text--function--active: var(--digi--color--text--secondary);
	--digi--button--icon--spacing: var(--digi--gutter--smaller);

	@include breakpoint.below-large {
		--digi--button--font-weight: var(--digi--global--typography--font-weight--regular);
		--digi--button--width: 100%;

		display: block;
		width: 100%;
	}
}

:host {
	::slotted(ul) {
		display: grid;
		grid-template-columns: 1fr;
		column-gap: var(--digi--container-gutter--medium);
		position: relative;

		@include breakpoint.large {
			grid-template-columns: 1fr 1fr;
		}

		a,
		[aria-current='page'] {
			@include link.base;

			font-size: var(--digi--global--typography--font-size--base);
			display: flex;
			align-items: center;
			flex-grow: 1;
			height: 100%;
			border-radius: var(--digi--border-radius--primary);
			padding-inline-start: var(--digi-navigation-main-menu--link-start-padding);
			font-weight: var(--digi--global--typography--font-weight--regular);
			min-height: var(--digi--global--spacing--largest-6);

			&:focus-visible {
				z-index: 1;
			}
		}

		// Styles for all list items on all levels
		li {
			--digi-navigation-main-menu-panel--list-item-expanded-background: var(--digi--color--background--secondary);

			@include breakpoint.below-large {
				display: grid;
				grid-template-columns: 1fr auto;
				column-gap: var(--digi--padding--largest);
			}

			@include breakpoint.large {
				display: flex;
				flex-direction: row;
				gap: var(--digi--padding--largest);
			}

			align-items: center;
			justify-content: space-between;
			min-height: var(--digi--global--spacing--largest-6);
			border-block-end: border.$list;
			padding-inline: 10px;

			@include breakpoint.below-large {
				padding-inline: 0;
			}

			&:first-child {
				border-block-start: border.$list;
			}

			li {
				&:last-child {
					border-block-end: none;
				}
			}

			@include breakpoint.large {
				&:hover,
				&[data-expanded='true'] {
					background: var(--digi-navigation-main-menu-panel--list-item-expanded-background);
				}
			}

			@include breakpoint.large {
				&[data-current] {
					background: linear-gradient(90deg, var(--digi--color--border--focus) 0%, var(--digi--color--border--focus) var(--digi--global--border-width--larger), var(--digi--color--background--tertiary) var(--digi--global--border-width--larger), var(--digi--color--background--tertiary) 100%);

					> a,
					> [aria-current='page'] {
						font-weight: var(--digi--global--typography--font-weight--semibold);
					}
				}
			}

			@include breakpoint.below-large {
				--digi-navigation-main-menu-panel--list-item-background: var(--digi--color--background--primary);
				--digi-navigation-main-menu-panel--list-item-border: var(--digi--color--background--primary);

				background: linear-gradient(
					90deg,
					var(--digi-navigation-main-menu-panel--list-item-border) 0%,
					var(--digi-navigation-main-menu-panel--list-item-border) var(--digi--global--border-width--larger),
					var(--digi-navigation-main-menu-panel--list-item-background) var(--digi--global--border-width--larger),
					var(--digi-navigation-main-menu-panel--list-item-background) 100%
				);

				&[data-current='exact'] {
					--digi-navigation-main-menu-panel--list-item-background: var(--digi--color--background--tertiary);
					--digi-navigation-main-menu-panel--list-item-border: var(--digi--color--border--focus);
				}
			}

			.digi-navigation-main-menu-panel__toggle-button {
				flex-shrink: 0;
				display: flex;
				align-items: center;
				justify-content: center;
				width: var(--digi--global--spacing--largest-4);
				height: var(--digi--global--spacing--largest-4);
				background: var(--digi-navigation-main-menu-panel--button-background);
				border-radius: 50%;
				border: border.$list;
				border-color: var(--digi--color--background--inverted-1);
				color: var(--digi--color--text--secondary);

				&[aria-expanded='true'] {
					--digi-navigation-main-menu-panel--icon-color: var(--digi--color--text--inverted);
					--digi-navigation-main-menu-panel--button-background: var(--digi--color--background--inverted-1);

					digi-icon:not([af-name='chevron-left']) {
						display: none;
					}
				}

				&:not([aria-expanded='true']) {
					digi-icon:not([af-name='chevron-right']) {
						display: none;
					}
				}

				digi-icon {
					display: flex;
					pointer-events: none;

					svg {
						--digi--icon--color: var(--digi-navigation-main-menu-panel--icon-color);
					}
				}

				&:focus-visible {
					outline: var(--digi--focus-outline);
				}

				@include breakpoint.below-large {
					transform: rotate(90deg);
					position: relative;
					left: calc(-1 * var(--digi--padding--small));
				}
			}

			@include breakpoint.below-large {
				li {
					.digi-navigation-main-menu-panel__toggle-button {
						background: transparent;
						border-color: transparent;

						@include breakpoint.below-large {
							transform: unset;
						}

						digi-icon {
							svg {
								--digi--icon--color: currentColor;
							}
						}

						&[aria-expanded='true'] {
							digi-icon:not([af-name='minus']) {
								display: none;
							}

							digi-icon[af-name='minus'] {
								display: flex;
							}
						}

						&:not([aria-expanded='true']) {
							digi-icon:not([af-name='plus']) {
								display: none;
							}

							digi-icon[af-name='plus'] {
								display: flex;
							}
						}
					}
				}
			}

			@include breakpoint.large {
				li {
					.digi-navigation-main-menu-panel__toggle-button {
						display: none;
					}
				}
			}
		}

		// Styles for list items on level 2 (level 1 is in the main menu)
		> li {
			--digi-navigation-main-menu-panel--list-item-expanded-background: var(--digi--color--background--primary);
			--digi-navigation-main-menu-panel--icon-color: currentColor;
			--digi-navigation-main-menu-panel--button-background: var(--digi--color--background--primary);
			--digi-navigation-main-menu--link-start-padding: 14px;

			@include breakpoint.below-large {
				--digi-navigation-main-menu--link-start-padding: var(--digi--padding--largest);
			}

			grid-column: 1;

			> ul {
				display: none;

				// Styles for list items on level 3 (level 1 is in the main menu)
				> li {
					--digi-navigation-main-menu-panel--icon-color: currentColor;

					@include breakpoint.below-large {
						--digi-navigation-main-menu-panel--list-item-border: var(--digi--color--background--tertiary);
					}

					> ul {
						// Styles for list items on level 4 and 5 (level 1 is in the main menu)
						li {
							--digi-navigation-main-menu-panel--icon-color: currentColor;

							@include breakpoint.below-large {
								--digi-navigation-main-menu--link-start-padding: 48px;
								--digi-navigation-main-menu-panel--list-item-border: var(--digi--color--background--tertiary);

								a,
								[aria-current='page'] {
									font-size: var(--digi--global--typography--font-size--small);
								}
							}
						}
					}
				}

				ul {
					display: none;
				}
			}

			[aria-expanded='true'] + ul {
				display: grid;

				@include breakpoint.below-large {
					grid-column: 1/-1;
				}

				@include breakpoint.large {
					ul {
						display: none;
					}
				}

				@include breakpoint.large {
					position: absolute;
					left: calc(50% + var(--digi--container-gutter--medium) / 2);
					top: 0;
					width: calc(50% - var(--digi--container-gutter--medium) / 2);
				}
			}
		}
	}
}
